/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


# ifndef DECODIEREN_H
# define DECODIEREN_H

# include <qobject.h>
# include <qwidget.h>
# include <qstring.h>
# include <qfiledialog.h>
# include <qtimer.h>
# include <qprocess.h>
# include <qmessagebox.h>

# include <cstdlib>                              // Fuer system()
# include <iostream>

# include "Daten.h"
# include "Aufruf.h"
# include "Neostring.h"
# include "Einstellungen.h"

class Decodieren : public QObject
{
    Q_OBJECT

    private:
        QString tempoutfilename,                 // Zur Kontrolle ob der zurueckgegeben Pfad auch etwas enthaelt
                ausgabe,                         // darin wird die Ausgabe fuer den mencoder Aufruf zusammen gebaut
                tempausgabe,                     // Damit der Ausgabestring zwischengespeichert wird fuer Anhaengen
                vorschaustring,                  // Fuer den Ausgabe string bei der Vorschau
                debugtemp,                       // Darin wird er Wert von der ComboBox gespeichert und dann umgewandelt
                ausgabenamen[30],                // Fuer zusammenfuegen, damit man die einzelnen datein nachher noch kennt
                mountpfad,                       // Der Ort wo die DVD's gemountet werden
                version,                         // Beinhaltet die Versionsnummer von dvd2xvid
                homepfad,                        // Beihnalte den hompfad des ausfuerne den Benutzers
                sprache,                         // Welche Sprache eingestellt ist
                ueberschrift,                    // Die Ueberschrift von diversen Messagboxen
                haupttext;                       // Der Text von diversen Messagboxen

        bool boolshutdown,                       // Ob der Computer nach h er heruntergefahren werden soll
             booleject,                          // Ob nach den Decodieren die Schublade geoefnnet werden soll
             boolunmount,                        // Ob nach den Decodieren die DVD mit unmount wieder entbunden werden soll
             boolzusammenfuegen,                 // Ob die Dateien nach den Decodieren zusammen gefuegt werden sollen
             boolpart,                           // Ob die part Datein beim zusammenfuegen nachher geloescht werden sollen
             bool2pass,                          // Ob auch im 2-Pass Modus encodiert werden soll
             boolanhalten,                       // Wenn diese Varibale ture ist dann halte beim naechsten Aufruf an
             boolletzter;                        // wird auf wahr gsetzt beim letzten Durchgang, (fuer Stapelfenster)

        short umwandeln,                         // zur kurzzeitigen ablage vom umgewandelten Wert der Integer Variable
              durchlauf;                         // Der wievielte Durchlauf es ist,also 2pass aufrufe werden nicht mit gezaehlt


        int debuglevel,                          // setzen des aktuellen Debuglevels
               zaehler;                           // Was gerade decodiert wird

        Daten *daten[10];                        // Darin werden die Encodierdaten gespeichert

        QWidget *eltern;                         // Darin wird der Zeiger zum Elternwidget abgelegt

        QTimer  *timer,                          // Ein Timer Objekt fuer das Verzoegern des Herunterfahrens
                *wartezeit;                      // Wartezeit bis zur Kontrolle ob der Aufruf schon fertig ist


        Aufruf *encodieraufruf;                  // Ein Thread Objekt fuer den Encodiervorgang

        Neostring neostring;                     // Wird fuer "sting_zerlegen" und "homepath" gebraucht

        Einstellungen einstellungen;             // Im Einstellungsobjekt sind die Standartwerte gespeichert

    public:

        Decodieren(QWidget *parent,QString versionsnummer);             // Konstruktor

    signals:

        // Wenn ein neuer Eingaebordner ausgewaehlt wurde dann wird dieses Signal gesendet mit den Ordnerpfad
        void ordnerausgewaehlt(QString);

        // Wenn ein nuer Titel ausgewaehlt wird dann werden die dazugehoerigen Tonund untertitel berrechnet
        void titelausgewaehlt(QString);

        // Damit die beid eDreier Fleder reuckgestzt werden
        void zeitfelderrucksetzen(void);

        // Sendet das Signal zum Schliessen des Programms
        void runterfahren (void);

        // Stellt alle Daten zusammen fuer die Stapelverabreitungsanzeige
        void aufruf(QString,QString,bool,bool,bool);

        // Wird gesendet wenn der Encodiervorgang zu Ende ist
        void fertig (void);

        // Die Fenster Unsichtbar machen
        void verstecken (void);

        // Schickt welcher Aufruf gerade encodiert wird
        void aktiveZeile(int,bool,bool);

    public slots:

        // darin wird der Aufruf fuer den ersten oder zweiten Durchlauf zusammengestellt und als QString zurueckgegeben
        QString bauen (int welcherDurchlauf,bool pass);

        // Erstellt einen File-Dialog der nur Ornder anzeigt und darin soll dann der Quell-Ordner ausgewaehlt werden 
        void setindirname(void);

        //Weist nur den indrinamen zu
        void set_indirname(QString name);

        // Erstellt einen File-Dialog fuer die Auswahl eines Pfades fuer die Zeil-Datei 
        void setoutname (void);

        // uebernimmt den Wert vom Aufrufer und weist ihm "boolcartoon" zu
        void setcartoon (bool cartoon);

        // uebernimmt den Wert vom Aufrufer und weist ihm "bool2pass" zu
        void set2pass (bool pass2);

        // uebernimmt den Wert vom Aufrufer und weist ihm "boolautoaspect" zu
        void setautoaspect(bool autoaspect);

        // uebernimmt den Wert vom Aufrufer und weist ihm "audioopt" zu
        void setauidoopt (const QString& audio);

        // uebernimmt den Wert vom Aufrufer und weist ihm "boolshutdown" zu
        void setshutdown (bool shutdown);

        // uebernimmt den Wert vom Aufrufer und weist ihm "bitrateopt" zu
        void setbitrateopt (const QString& bitrate);

        // uebernimmt den Wert vom Aufrufer und weist ihm "titelnummer" zu
        void settitel (int titel);

        // uebernimmt den Wert vom Aufrufer und weist ihm "alang" zu
        void setaudio (const QString& audio);

        // uebernimmt den Wert vom Aufrufer und weist ihm "alang" zu
        void setuntertitel(const QString& untertitel);

        // uebernimmt den Wert vom Aufrufer und weist ihm "debuglevel" zu
        void setdebug(int auswahl);

        // uebernimmt den Wert vom Aufrufer und weist ihm "boolpart" zu
        void setpart (bool part);

        // uebernimmt den vhq Wert und weist ihn "vhqWert" zu
        void setvhq (const QString& vhq);

        // uebernimmt den Wert vom Aufrufer und weist ihm "mountpfad" zu
        void setmountpfad (QString mount);

        // Den uebergeben wert "sprache zuweisen
        void setsprache (QString neuesprache);

        // Gibt den aufbereiteten indirnammen zurueck
        QString getindirname(void);

        // Giebt den Mount-Point der DVD zurueck
        QString getmountpfad (void);

        // Gibt denn Wert der "boolcartoon" Variable zurueck
        bool getcartoon(void);

        // Gibt denn Wert der "bool2pass" Variable zurueck
        bool get2pass(void);

        // Gibt denn Wert der "boolautoaspect" Variable zurueck
        bool getautoaspect(void);

        // Giebt den momentan vhqWert zurueck
        QString getvhq (void);

        // Gibt denn Wert der "boolshutdown" Variable zurueck
        bool getshutdown(void);

        // Gibt denn Wert der "boolunmount" Variable zurueck
        bool getunmount (void);

        // Gibt denn Wert der "boolshutdown" Variable zurueck
        bool geteject (void);

        // Gibt denn Wert der "boolzusammenfugen" Variable zurueck
        bool getzusammenfuegen(void);

        // Gibt denn Wert der "boolpart" Variable zurueck
        bool getpart (void);

        // Gibt den Debuglevel wert zurueck
        int getdebug (void);

        // Gibt die momentane Sprache zurueck
        QString getsprache (void);

        // uebernimmt den Wert vom Aufrufer und weist ihm "boolunmount" zu
        void setboolunmount (bool unmount);

        // uebernimmt den Wert vom Aufrufer und weist ihm "booleject" zu
        void setbooleject (bool eject);

        // kontrolliert ob die Datein am Ende zusammne gefuegt werden sollen
        void setzusammenfuegen (bool zusammenfuegen);

        // Gibt denn Wert des "audioopt" Strings zurueck
        QString getaudioopt (void);

        // Gibt denn Wert des "bitrateopt" Strings zurueck
        QString getbitrateopt (void);

        // Setzt alle Einstellungen wieder zurueck
        void ruecksetzen(void);

        // Laedet alle Einstellungen
        void laden (void);

        // Speichert all einstellungen
        void speichern (void);

        // Weist die Werte aus Einstellungen den Varibalen zu
        void zuweisen (void);

        // Vorschau der bisherigen Einstellungen
        void vorschau (void);

        // Startet den Decodieren Aufruf
        void starten (void);

        // erstellt den String fuers anhaengen und gibt eine Meldung an die Console aus
        void anhaengen (void);

        // setzen der Startzeit 
        void setstartzeit(const QString& zeit);

        // setzen der Endzeit 
        void setendzeit(const QString& zeit);

        // Laesst das System herunterfahren
        void herunterfahren (void);

        // Soll das zusammen fuegen von fertigen Datein ermoeglichen
        void zusammenfuegen (void);

        // Soll die temporaeren ".part" Dateien loeschen
        void delpart (void);

        // Baut noch einen Aufruf zusammen und fuert dann starten() aus
        void encodieren(void);

        // Setzt die Durchlauf und  Stringvar Variblen zurueck
        void var_reset(void);

        // Kontrolliert ob noch decodiert wird
        void checkaufruf (void);

        // Werte vom vorherigen aufruf zuweisen
        void vorherigeZuweisen (int var);

        // Der naechste Encodirvorgang soll nicht mehr Ausgefuehrt werden
        void anhalten(void);

        // Der Encodirvorgang soll sofort unterbrochen werden
        void abbrechen(void);
};

# endif
