/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# include "Gui.h"

# ifndef GUI_CPP
# define GUI_CPP

Gui::Gui(int startdebuglevel,string versionsnummer)
{
    // Den Anfangs debuglevel festlegen
    debuglevel=startdebuglevel;

    // Versionnummer zuordnen
    version=versionsnummer;

    if(debuglevel>0)
    {
        cout<<" * gui.cpp = *"<<endl<<endl;
        cout<<" Startdebuglevel : "<<startdebuglevel<<endl<<endl;
    }

    // Namen die Versionnummer hinzufuegen fuer die anzeige in der titelleiste
    name="dvd2xvid "+versionsnummer;

    short hoehe      = 390,                      // fuer die Hoehe des Fensters
          zeile      =  30,                      // fuer die Vertikale   Position des Labels
          spalte_1   =  10,                      // fuer die  1 Horizontale Position des Labels
          spalte_2   = 255;                      // fuer die  2 Horizontale Position des Labels
          breite     = 490;                      // die Breite des Fensters

    // Damit der Erste Aufruf von Mount auch stimmt
    boolmount      = false;
    boolmounterror = false;

    // Damit  QApplication ruhe gibt
    char *argv[1]={""};
    int argc=0;

    // Instantierung eines QApplication-Objekts; immer notwendig
    QApplication app(argc,argv);

    // Erstellen des Hauptfensters
    window = new QWidget();

    // Fuer die Anzeige des Fensternamens in der Teitelzeile
    window->setCaption(name);

    // Ermittelt die Bildschirm Groesse und Plaziert das Fenster fast ganz rechts
    positionieren();

    // legt die Groesse des Fensters und die Position am Bildschirm fest
    window->setGeometry(poshor,posver,breite,hoehe);

    // Festlegen der Minimum und Maximumgroesse des Fensters
    window->setMinimumSize (breite, hoehe);
    window->setMaximumSize(breite, hoehe);

    // Wien QPixmap Objekt erzeugen dem das Bild "dvd.png" uebergeben wird
    QPixmap *icon = new QPixmap("/usr/share/dvd2xvid/icons/dvd2xvid32.png");

    // Dem Programm das Icon zuweisen
    window->setIcon(*icon);

    // Diese Klasse enthaelt die Slots fuer die uebergabe an Mencoder
    decodieren = new Decodieren(window,versionsnummer);

    // Den abgespeicherten Debuglevel zuweisen
    debuglevel=decodieren->getdebug();

    // fuegt die Menuebar hinzu
    menubar= new Menuebar(window,decodieren,debuglevel);

    // Fuer das Mounten der DVD
    process_mounten = new QProcess(this);

    // Das Stapelfenster erstellen
    stapel = new Stapelfenster(window,poshor,posver+hoehe+29,decodieren);

    /************************************/
    /*           Knoepfe                */
    /************************************/

    // Erstellt den Konpf "Ordner fuer Eingabe auswaehlen" 
    indir = new QPushButton("...",window);
    indir->setFont(QFont("SansSerif",11));
    indir->setGeometry(spalte_1+205,zeile*1,25,25);

    // Erstellt den Konpf "Ausgabe Datei auswaehlen"
    outfile = new QPushButton("...",window);
    outfile->setFont(QFont("SansSerif",11));
    outfile->setGeometry(spalte_1+205,zeile*2,25,25);

    // der Codiervorgang soll gestartet werden
    encodieren = new QPushButton(window);
    encodieren->setFont(QFont("SansSerif",11));
    encodieren->setGeometry(breite-192,hoehe-35,86,25);

    // Alle Einstellungen speicher
    beenden = new QPushButton(window);
    beenden->setFont(QFont("SansSerif",11));
    beenden->setGeometry(breite-96,hoehe-35,86,25);

    //Vorschau mit den bissherigen Einstellungen
    vorschau = new QPushButton(window);
    vorschau->setFont(QFont("SansSerif",11));
    vorschau->setGeometry(spalte_1,hoehe-35,86,25);

    //Encodiern noch nicht starten und ausgabe String Temporaer speichern
    anhaengen = new QPushButton(window);
    anhaengen->setFont(QFont("SansSerif",11));
    anhaengen->setGeometry(spalte_1+192,hoehe-35,86,25);

    // Mountet die DVD
    mount = new QPushButton(window);
    mount->setFont(QFont("SansSerif",11));
    mount->setGeometry(spalte_1+96,hoehe-35,86,25);

    // ob mit Cartonn Optimierung gearbeitet werden soll
    cbcartoon = new QCheckBox(window);
    cbcartoon->setGeometry(spalte_1+215,(zeile*3)+5,20,20);

    // ob im 2-Pass Modus Decodiert werden soll soll
    cb2pass = new QCheckBox(window);
    cb2pass->setGeometry(spalte_1+215,(zeile*4)+5,20,20);

    // Ob die Seitenverhaeltnise automatisch berechnet werden sollen
    cbautoaspect = new QCheckBox(window);
    cbautoaspect->setGeometry(spalte_1+215,(zeile*5)+5,20,20);

    // Mit welcher VHQ Qualitaet gearbeite werden soll
    cobvhq = new QComboBox(window);
    cobvhq->setFont(QFont("SansSerif",11));
    cobvhq->setGeometry(spalte_1+180,(zeile*6),48,25);

    // Eintraege fuer "covhq"
    cobvhq->insertItem("0");
    cobvhq->insertItem("1");
    cobvhq->insertItem("2");
    cobvhq->insertItem("3");
    cobvhq->insertItem("4");

    // Darin wird dann ausgewaehlt wie der Audio bereich decodiert werden soll
    cobaudio = new QComboBox(window);
    cobaudio->setFont(QFont("SansSerif",11));
    cobaudio->setGeometry(spalte_2,zeile*2,220,22);

    // Eintraege fuer "coauido"
    cobaudio->insertItem("copy");
    cobaudio->insertItem("mp3lame");
    cobaudio->insertItem("pcm");
    //cobaudio->insertItem("lavc");

    // Darin wird dann ausgewaehlt mit welcher Bitrate konvertiert werden soll
    cobitrate = new QComboBox(window);
    cobitrate->setFont(QFont("SansSerif",11));
    cobitrate->setGeometry(spalte_2,zeile*4,220,22);

    // Eintraege fuer "cobitrate"
    cobitrate->insertItem("200");
    cobitrate->insertItem("400");
    cobitrate->insertItem("600");
    cobitrate->insertItem("800");
    cobitrate->insertItem("1000");
    cobitrate->insertItem("1200");
    cobitrate->insertItem("1400");
    cobitrate->insertItem("1600");
    cobitrate->insertItem("1800");
    cobitrate->insertItem("2000");

    // Darin wird dann ausgewaehlt welcher Titel decodiert werden soll
    QComboBox *cotitel = new QComboBox(window);
    cotitel->setFont(QFont("SansSerif",11));
    cotitel->setGeometry(spalte_2,zeile*6,220,22);

    // Darin wird dann ausgewaehlt welcher Audiospur decodiert werden soll
    QComboBox *coalang= new QComboBox(window);
    coalang->setFont(QFont("SansSerif",11));
    coalang->setGeometry(spalte_2,zeile*8,220,22);

    // Darin wird dann ausgewaehlt welcher unterdtitel mit decodiert werden soll
    QComboBox *countertitel = new QComboBox(window);
    countertitel->setFont(QFont("SansSerif",11));
    countertitel->setGeometry(spalte_2,zeile*10,220,22);

    // Diese Klasse enthaelt die Slots fuer das Auslesen der DVD-Infos
    lsdvd = new Lsdvd(cotitel,coalang,countertitel,decodieren,debuglevel);

    // Start Zeitfeld erstellen
    startfeld= new Zeitfelder(window,spalte_1,zeile*8,debuglevel);

    // End Zeitfeld erstellen
    endfeld  = new Zeitfelder(window,spalte_1,zeile*10,debuglevel);

    /************************************/
    /*             Labels               */
    /************************************/

    // Label fuer "outname"
    labelindirname = new QLabel(window);
    labelindirname->setFont(QFont("SansSerif",11));
    labelindirname->setGeometry(spalte_1,zeile*1,195,25);

    // Label fuer "outnaladenme"
    labeloutname = new QLabel(window);
    labeloutname->setFont(QFont("SansSerif",11));
    labeloutname->setGeometry(spalte_1,zeile*2,195,25);

    // Beschriftung fuer "cbcartoon" (CartoonOptimierung aktivieren)
    labelcartoon = new QLabel(window);
    labelcartoon->setFont(QFont("SansSerif",11));
    labelcartoon->setGeometry(spalte_1,zeile*3,215,25);

    // Beschriftung fuer "cb2pass" (2-Pass Decodierung aktivieren)
    label2pass = new QLabel(window);
    label2pass->setFont(QFont("SansSerif",11));
    label2pass->setGeometry(spalte_1,zeile*4,215,25);

    // Beschriftung fuer "cbautoaspect" (CartoonOptimierung aktivieren)
    labelautoaspect = new QLabel(window);
    labelautoaspect->setFont(QFont("SansSerif",11));
    labelautoaspect->setGeometry(spalte_1,zeile*5,215,25);

    // Beschriftung fuer "cbvhq" (CartoonOptimierung aktivieren)
    labelvhq = new QLabel(window);
    labelvhq->setFont(QFont("SansSerif",11));
    labelvhq->setGeometry(spalte_1,zeile*6,180,25);

    // Beschriftung fuer "labelaudio" (Audio Encodierungs Optionen)
    labelaudio = new QLabel(window);
    labelaudio->setFont(QFont("SansSerif",11));
    labelaudio->setGeometry(spalte_2,zeile*1,210,25);

     // Beschriftung fuer "labelbitrate" (Bitrate Encodierungs Optionen)
    labelbitrate = new QLabel(window);
    labelbitrate->setFont(QFont("SansSerif",11));
    labelbitrate->setGeometry(spalte_2,zeile*3,210,25);

     // Beschriftung fuer "labeltitel" (Welcher Titel decodiert werden soll)
    labeltitle = new QLabel(window);
    labeltitle->setFont(QFont("SansSerif",11));
    labeltitle->setGeometry(spalte_2,zeile*5,210,25);

    // Beschriftung fuer "coslang" 
    labelalang= new QLabel(window);
    labelalang->setFont(QFont("SansSerif",11));
    labelalang->setGeometry(spalte_2,zeile*7,230,25);

    // Beschriftung fuer "countertitel"
    labeluntertitel = new QLabel(window);
    labeluntertitel->setFont(QFont("SansSerif",11));
    labeluntertitel->setGeometry(spalte_2,zeile*9,230,25);

    // Beschriftung fuer "startzeit"
    labelstartzeit = new QLabel(window);
    labelstartzeit->setFont(QFont("SansSerif",11));
    labelstartzeit->setGeometry(spalte_1,zeile*7,215,25);

    // Beschriftung fuer "endezeit"
    labelendezeit = new QLabel(window);
    labelendezeit->setFont(QFont("SansSerif",11));
    labelendezeit->setGeometry(spalte_1,zeile*9,215,25);

    // Abgrenzungslinie ueber den Knoepfen
    QFrame *linie = new QFrame(window);
    linie->setPaletteForegroundColor(Qt::lightGray);
    linie->setFrameStyle(QFrame::HLine|QFrame::Plain);
    linie->setLineWidth(1);
    linie->setGeometry(5,hoehe-50,breite-10,3);
    //linie->update();

    /************************************/
    /*              Events              */
    /************************************/

    // Benenden das Programm
    QObject::connect(beenden,         SIGNAL(released()),                &app,          SLOT(quit()));
    QObject::connect(decodieren,      SIGNAL(runterfahren()),            &app,          SLOT(quit()));
    QObject::connect(menubar,         SIGNAL(exit()),                    &app,          SLOT(quit()));

     // Der Encodiervorgang ist gestartet worden mache die Fenster unsichtbar
    QObject::connect(decodieren,      SIGNAL(verstecken()),            window,          SLOT(hide()));
    //QObject::connect(decodieren,      SIGNAL(verstecken()),            stapel,          SLOT(hide()));

    // Beim Druecken von von "Encodieren" soll der decodiervorgang gestartet werden
    QObject::connect(encodieren,      SIGNAL(released()),           decodieren,         SLOT(encodieren()));

    // Mountet einen DVD beim drueken des Knopfes
    QObject::connect(mount,           SIGNAL(released()),                   this,         SLOT(mounten()));

    // Beim Druecken von von "speichern" sollen alle Einstellungen gespeichert werden
    QObject::connect(menubar,         SIGNAL(speichern()),               decodieren,    SLOT(speichern()));

    // Beim Druecken von von "anhaengen" wird der momentan Auftrag angehaengt
    QObject::connect(anhaengen,       SIGNAL(released()),                 decodieren,    SLOT(anhaengen()));

    // Nach den Einbindne der DVD soll die DVD gleich ausgwaehlt werden
    QObject::connect(process_mounten, SIGNAL(processExited()),           this,          SLOT(setindirname()));

    // Wenn etwas aus der Errorausgabe zum lesen kommt, dann rufe lesemount auf und damit gebe eine Strung aus
    QObject::connect(process_mounten, SIGNAL(readyReadStderr()),         this,          SLOT(lese_mount()));

    // Beim Druecken von von "Decodieren" soll der decodiervorgang gestartet werden
    QObject::connect(menubar,         SIGNAL(standard()),                this,          SLOT(ruecksetzen()));

    // Wenn in der Menueleiste die Sprache veraendert wird dann stell sie hier um
    QObject::connect(menubar,         SIGNAL(english()),                 this,          SLOT(setEnglish()));

    // Wenn in der Menueleiste die Sprache veraendert wird dann stell sie hier um
    QObject::connect(menubar,         SIGNAL(deutsch()),                 this,          SLOT(setDeutsch()));

    // Beim Druecken von von "Vorschau" soll Mplayer mit den Audio- und Untertitel-einstellungen gestartet werden
    QObject::connect(vorschau,        SIGNAL(released()),                 decodieren,    SLOT(vorschau()));

    // Der Eingegeben Name wird dem Slot "setoutname" uebergeben 
    QObject::connect(outfile,         SIGNAL(released()),                 decodieren,    SLOT(setoutname()));

    // Sagt den Knopf "indir" das wenn er gedrueckt wird der FileDialog geoeffnet werden soll, ueber den Slot "setindirname" 
    QObject::connect(indir,           SIGNAL(released()),                 decodieren,    SLOT(setindirname()));

    // Wenn die Checkbox aktiviert wird wird das Siganl an "setcartoon" weietrgegeben
    QObject::connect(cbcartoon,       SIGNAL(toggled(bool)),             decodieren,    SLOT(setcartoon(bool)));

     // Wenn die Checkbox aktiviert wird wird das Siganl an "set2pass" weietrgegeben
    QObject::connect(cb2pass,         SIGNAL(toggled(bool)),             decodieren,    SLOT(set2pass(bool)));

    // Wenn in der ComboBob etwas aktiviert wird wird der Int  an "setvhq" weietrgegeben
    QObject::connect(cobvhq,          SIGNAL(activated(const QString&)), decodieren,    SLOT(setvhq(const QString&)));

    // Wenn die Checkbox aktiviert wird wird das Siganl an "setautoaspect" weietrgegeben
    QObject::connect(cbautoaspect,    SIGNAL(toggled(bool)),             decodieren,    SLOT(setautoaspect(bool)));

     // Wenn in der ComboBob etwas aktiviert wird wird der Stringwert  an "setaudioopt" weietrgegeben
    QObject::connect(cobaudio,        SIGNAL(activated(const QString&)), decodieren,    SLOT(setauidoopt(const QString&)));

    // Wenn in der ComboBob etwas aktiviert wird wird der Stringwert  an "setbitrateopt" weietrgegeben
    QObject::connect(cobitrate,       SIGNAL(activated(const QString&)), decodieren,    SLOT(setbitrateopt(const QString&)));

    // Wenn in der ComboBob etwas aktiviert wird wird der Stringwert  an "setbitrateopt" weietrgegeben
    QObject::connect(cotitel,         SIGNAL(activated(int)), decodieren,               SLOT(settitel(int)));

    // Wenn in der ComboBob etwas aktiviert wird wird der Stringwert  an "setaudio" weietrgegeben
    QObject::connect(coalang,         SIGNAL(activated(const QString&)), decodieren,    SLOT(setaudio(const QString&)));

    // Wenn in der ComboBob etwas aktiviert wird wird der Stringwert  an "setuntertitel" weietrgegeben
    QObject::connect(countertitel,    SIGNAL(activated(const QString&)), decodieren,    SLOT(setuntertitel(const QString&)));

    // Wenn ein neuer Ordner ausgweaehlt wird soll dort nach Titel informationen gesucht werden
    QObject::connect(decodieren,      SIGNAL(ordnerausgewaehlt(QString)),lsdvd,         SLOT(titeleinlesen(QString)));

    // Wenn ein titel ausgweaehlt wird sollen neue Audioinformationen eingelesen werden
    QObject::connect(decodieren,      SIGNAL(titelausgewaehlt(QString)),lsdvd,          SLOT(audioeinlesen(QString)));

    // Wenn ein titel ausgweaehlt wird sollen neue Untertitelinformationen eingelesen werden
    QObject::connect(decodieren,      SIGNAL(titelausgewaehlt(QString)),lsdvd,          SLOT(untertiteleinlesen(QString)));

    // Wenn eines der Felder in der Startzeit geandert worden ist dann schicke das Signal weiter
    QObject::connect(startfeld,       SIGNAL(zeitgeaendert(const QString&)), decodieren,SLOT(setstartzeit(const QString&)));

    // Wenn eines der Felder in der Endzeit geandert worden ist dann schicke das Signal weiter
    QObject::connect(endfeld,         SIGNAL(zeitgeaendert(const QString&)), decodieren,SLOT(setendzeit(const QString&)));

    // Setzt alle Werte auf Null von endfeld
    QObject::connect(decodieren,      SIGNAL(zeitfelderrucksetzen()),endfeld,          SLOT(ruecksetzen()));

    // Setzt alle Werte auf Null von startfeld
    QObject::connect(decodieren,      SIGNAL(zeitfelderrucksetzen()),startfeld,        SLOT(ruecksetzen()));

    // Da der Encodiervorgang zu Ende ist loesche das Stapelfenster 
    QObject::connect(decodieren,      SIGNAL(fertig()),                   this,      SLOT(fertig()));

    // Wenn der String nur angeaengt wird dann Fuege diese Spaltehinzu
    QObject::connect(decodieren,      SIGNAL(aufruf(QString,QString,bool,bool,bool)),     stapel,
                                      SLOT(addZeile(QString,QString,bool,bool,bool)));

    // Aendert den Text der Ueberschrift vom Stapefenster
    QObject::connect(decodieren,      SIGNAL(aktiveZeile(int,bool,bool)),     stapel,     SLOT(setUeberschrift(int,bool,bool)));

    // Beim Druecken von von "speichern" sollen alle Einstellungen gespeichert werden
    QObject::connect(menubar,         SIGNAL(debugwert(int)),               this,      SLOT(setDebug(int)));

    // Die Einstellungen Sichtbar machen
    anzeigen();

    // Momentane Sprache auswaehlen
    sprache=decodieren->getsprache();

    // Wenn die Varibale "de" ist dann setze alles auf Deutsch
    if(sprache=="de")
    {
        setDeutsch();
    }
    else
    {
        // Wenn die Varibale "en" ist dann setze alles auf English
        if(sprache=="en")
        {
            setEnglish();
        }
    }

    // sagt der qtAplication das "window" das Hauptwidget ist
    app.setMainWidget(window);

    // Damit man die eventuell vorhandnen Titelinvormationen im gespeicherten indirorner holt
    lsdvd->titeleinlesen(decodieren->getindirname());

    // damit das  Hautfenster "window" auch sichtbar wird
    window->show();

    // starte dann das Programm
    app.exec();

}

void Gui::ruecksetzen(void)
{
    // Laesst alle Einstellungen auf den Standartwert setzen
    decodieren->ruecksetzen();
    endfeld   ->ruecksetzen();
    startfeld ->ruecksetzen();
    menubar   ->ruecksetzen();
    anzeigen();
}

void Gui::anzeigen(void)
{
    // Die Sandart Wert abholen und diese sichtbar machen
    cobitrate   ->setCurrentText(decodieren->getbitrateopt());
    cobaudio    ->setCurrentText(decodieren->getaudioopt());
    cobvhq      ->setCurrentText(decodieren->getvhq());

    cbautoaspect->setChecked(decodieren->getautoaspect());
    cb2pass     ->setChecked(decodieren->get2pass());
    cbcartoon   ->setChecked(decodieren->getcartoon());

    // Momentane Sprache auswaehlen
    sprache=decodieren->getsprache();

    // Wenn die Varibale "de" ist dann setze alles auf Deutsch
    if(sprache=="de")
    {
        setDeutsch();
    }
    else
    {
        // Wenn die Varibale "en" ist dann setze alles auf English
        if(sprache=="en")
        {
            setEnglish();
        }
    }
}

void Gui::mounten(void)
{
    if (boolmount==false)
    {
        // Eventuell alte Argumente Loeschen
        process_mounten->clearArguments();

        // Den Mount Befehl als Argumen Uebergeben
        process_mounten->addArgument("mount");

        // Den Ort zum Mounten als Argument Uebergeben
        process_mounten->addArgument(decodieren->getmountpfad());

        // Starten des QProcess , also jetzt wird gemountet
        process_mounten->start();

    }
    else
    {
        // Umountet einen Eingelegte DVD
        system(("umount "+decodieren->getmountpfad()));

        // Damit der Befehl auch sichtbar wird
        cout<<endl<<" umount "<<decodieren->getmountpfad()<<endl<<endl;

        // Den Indir Ordner wieder nochmal anwaehlen damit die Titelinfarmationen rueckgestzt werden
        decodieren->set_indirname(decodieren->getmountpfad());

        // Damit der naechste Aufruf die DVD wieder einbindet
        boolmount=false;
    }
}

void Gui::setindirname (void)
{
    // Kotrolle ob es einen Fehler gegeben hat
    if(boolmounterror==false)
    {
        // Damit der Befehl auch sichtbar wird
        cout<<endl<<" mount "<<decodieren->getmountpfad()<<endl<<endl;

        // damit der naechste Aufruf die DVD wieder ausbindnet
        boolmount=true;

        // Denn DVD Ordner gleich Auswaehlen
        decodieren->set_indirname(decodieren->getmountpfad());
    }

    // Den Fehlerspriecher wieder rueckgaenig machen
    boolmounterror=false;

    // Kontrolle ob das ein Fehler war weil die DVD schon eingebunden war
    if(temp.left(25)=="mount: according to mtab,")
    {
        // damit der naechste Aufruf die DVD wieder ausbindnet
        boolmount=true;

        // Denn DVD Ordner gleich Auswaehlen
        decodieren->set_indirname(decodieren->getmountpfad());
    }
}

void Gui::lese_mount (void)
{

    //Damit er sich merkt das es einen Fehler gegeben hat
    boolmounterror=true;

    // Auslesen der mount Meldung
    temp=process_mounten->readLineStderr();

    if(debuglevel==3)
    {
        cout<<temp<<endl;
    }

    if(temp.left(22)=="mount: No medium found")
    {
        if (sprache=="de")
        {
            // Meldung ausgeben das keine DVD im Laufwerk gefunden wurde
            QMessageBox::critical(window,"Fehler beim Mounten","Keine DVD im Laufwerk gefunden.",
                                    QMessageBox::Ok,QMessageBox::NoButton,QMessageBox::NoButton);
        }

        if (sprache=="en")
        {
            // Meldung ausgeben das keine DVD im Laufwerk gefunden wurde
            QMessageBox::critical(window,"Error","No DVD found in the drive.",
                                  QMessageBox::Ok,QMessageBox::NoButton,QMessageBox::NoButton);
        }
    }
    else
    {
        if(temp.left(17)=="mount: can't find")
        {
            if(sprache=="de")
            {
                // Meldung ausgeben das es den DVD- Mountpoint nicht gibt
                QMessageBox::critical(window,"Fehler beim Mounten","Mountpfad konnte nicht gefunden werden.",
                                                 QMessageBox::Ok,QMessageBox::NoButton,QMessageBox::NoButton);
            }

            if(sprache=="en")
            {
                // Meldung ausgeben das es den DVD- Mountpoint nicht gibt
                QMessageBox::critical(window,"Error","Mountpath can't be found.",
                                      QMessageBox::Ok,QMessageBox::NoButton,QMessageBox::NoButton);
            }
        }
        else
        {
            if(temp.left(25)=="mount: according to mtab,")
            {
                // Nichts nur, dieser Fall wird spaeter behandelt,siehe Gui::setindirname()  
            }
            else
            {
                if(temp.right(4)=="busy")
                {
                    // Nichts nur, dieser Fall wird spaeter behandelt,siehe Gui::setindirname()
                }
                else
                {
                    // Meldung an die Konsole das es einen Fehler gegeben hat
                    cout<<endl<<" Unbekannten Fehler beim Mounten der DVD."<<endl;
                    cout<<temp<<endl<<endl;
                }
            }
        }
    }
}

void Gui::positionieren (void)
{
    QDesktopWidget *Desktop =  qApp->desktop();

    //Auf welchen Desktop luft das Programm? 
    int Schirmnummer=Desktop->screenNumber(window);

    //wie gross ist dieser? 
    QRect Bildschirmgroesse=Desktop->availableGeometry(Schirmnummer);

    //neue x Position ergibnt sich aus Bildschirmgroesse-Programmgroesse/2
    poshor=(Bildschirmgroesse.width()-(breite+20));

    posver=20;
}

void Gui::setDeutsch(void)
{
    // Sprache abspeichern
    sprache="de";

    // Menueleiste auch auf English setzen
    menubar->setDeutsch();

    // Sprache an decodieren senden (fuer Einstellunegn)
    decodieren->setsprache(sprache);

    // Die Sprache vom Staplefenster aendern
    stapel->setDeutsch();

    // Die Sprache in Lsdvd aenderen
    lsdvd->setDeutsch();

    // Im Hauptfenster die Knoepfe umbennen
    beenden    ->setText("Beenden");
    vorschau   ->setText("Vorschau");
    anhaengen  ->setText("Anhaengen");
    encodieren ->setText("Encodieren");
    mount      ->setText("Mount DVD");

    // Im Hauptfenster die Labels umbennen
    labelindirname ->setText("Eingabeordner auswaehlen:");
    labeloutname   ->setText("Ausgabedatei auswaehlen:");
    labelcartoon   ->setText("Cartoon-Optimierung aktivieren");
    label2pass     ->setText("2-Pass Encodierung aktivieren");
    labelautoaspect->setText("Autoaspect-Option aktivieren");
    labelvhq       ->setText("Bewegungsabschaetzung");
    labelaudio     ->setText("Audio Encodierungsoptionen:");
    labelbitrate   ->setText("Bitrate Encodierungsoptionen:");
    labeltitle     ->setText("Welchen Titel encodieren:");
    labelalang     ->setText("Mit welcher Audiospur encodieren:");
    labeluntertitel->setText("Mit welchem Untertitel encodieren:");
    labelstartzeit ->setText("Beginne Encodierung bei:");
    labelendezeit  ->setText("Beende Encodierung bei:");

    // Kleine Hilfen die Erscheinen wenn der Mauszeiger darueber verweilt
    QToolTip::setWakeUpDelay(2000);
    QToolTip::setFont(QFont("SansSerif",11));
    QToolTip::add( beenden,     "Beendet das Programm." );
    QToolTip::add( encodieren,  "Beginnt mit der Encodierung." );
    QToolTip::add( anhaengen,   "Fuegt den Auftrag in die Stapelverarbeitung ein." );
    QToolTip::add( vorschau,    "Startet Mplayer mit den eingestellten Optionen fuer \n Ton-, Untertitel- und Titeleinstellungen." );
    QToolTip::add( mount,       "Einbinden und auswaehlen des DVD-Laufwerks.\nBei erneuter Betaetigung loesen der Laufwerkseinbindung.");
    QToolTip::add( cb2pass,     "Im 2Pass Modus wird vor dem eigentlichen\nEncodieren ein Analysedurchlauf durchgefuert. \nDies dauert zwar fast doppelt so lange, ergibt\njedoch eine merklich bessere Qualitaet bei\nselber Dateigroesse." );
    QToolTip::add( cbautoaspect,"Damit wird das Seitenverhaeltnis automatisch richtig gestellt." );
    QToolTip::add( cbcartoon,   "Bessere Encodierung bei Zeichentrick." );
    QToolTip::add( cobvhq,      "Der Algorithmus fr die Bewegungsabschtzung basiert auf der Suche im\nFarbraum und versucht, einen Motion-Vector zu finden, der die Differenz\nzwischen dem ursprnglichen und dem encodierten Frame minimiert.\n0= aus (Standard), 1= Entscheidung des Modus (Inter-/Intra-Macro-Block)\n2= begrenzte Suche, 3= mittlere Suche, 4= ausgiebige Suche" );
}

void Gui::setEnglish(void)
{
    // Sprache abspeichern
    sprache="en";

    // Menueleiste auch auf English setzen
    menubar->setEnglish();

    // Sprache an decodieren senden (fuer Einstellunegn)
    decodieren->setsprache(sprache);

    // Die Sprache vom Staplefenster aendern
    stapel->setEnglish();

    // Die Sprache in Lsdvd aenderen
    lsdvd->setEnglish();

    // Im Hauptfenster die Knoepfe umbennen
    beenden    ->setText("Quit");
    vorschau   ->setText("Preview");
    anhaengen  ->setText("Append");
    encodieren ->setText("Encoding");
    mount      ->setText("Mount DVD");

    // Im Hauptfenster die Labels umbennen
    labelindirname ->setText("Select infile:");
    labeloutname   ->setText("Select outfile:");
    labelcartoon   ->setText("Activate cartoonoption");
    label2pass     ->setText("Activate 2-Pass encoding");
    labelautoaspect->setText("Activate autoaspectoption");
    labelvhq       ->setText("Motion search algorithm");
    labelaudio     ->setText("Audio encodingoption:");
    labelbitrate   ->setText("Bitrate encodingoption:");
    labeltitle     ->setText("Select title:");
    labelalang     ->setText("Select audiotrack:");
    labeluntertitel->setText("Select subtitle:");
    labelstartzeit ->setText("Start encoding by:");
    labelendezeit  ->setText("Stop encoding by:");

    // Kleine Hilfen die Erscheinen wenn der Mauszeiger darueber verweilt
    QToolTip::setWakeUpDelay(2000);
    QToolTip::setFont(QFont("SansSerif",11));
    QToolTip::add( beenden,     "Quit the application." );
    QToolTip::add( encodieren,  "Start the encoding." );
    QToolTip::add( anhaengen,   "Add job to batch processinglist." );
    QToolTip::add( vorschau,    "Starts Mplayer with choosen audiotrack,\nsubtitle and titlesettings." );
    QToolTip::add( mount,       "Mount and chose the DVD-Drive.\nWhith the second click umount DVD_Drive.");
    QToolTip::add( cb2pass,     "Pass one analyzes the video. Pass two uses\nthis information to do the optimized encoding.\nThis needs two times longer but results in a \nperceptible better quality, by same filesize" );
    QToolTip::add( cbautoaspect,"Corrects aspect ratio automatically." );
    QToolTip::add( cbcartoon,   "Optimized encoding by cartoons." );
    QToolTip::add( cobvhq,      "The motion search algorithm is based on a search in the usual color domain\nand tries to find a motion vector that minimizes\nthe difference between the reference frame and the encoded frame.\n0=off (default), 1=mode decision (inter/intra MB), 2= limited search,\n3= medium search, 4= wide search" );

}

void Gui::setDebug(int neuerdebug)
{
    cout<<" Neuer Debuglevel ausgewaehlt = "<<neuerdebug<<endl<<endl; 

    // Den neuen Debuglevel wert speicheren
    debuglevel=neuerdebug;

    // Debuglevel wert in zu Lsdvd schicken
    lsdvd->setDebug(debuglevel);

    //Bei den zwei Zeitfelder auch den Debugwert setzen
    startfeld->setDebug(debuglevel);
    endfeld  ->setDebug(debuglevel);

}

void Gui::fertig (void)
{
    // Damit die Ueberschirft wieder richtig dagestellt wird
    if(sprache=="de")
    {
        stapel->setDeutsch();
    }
    else
    {
        stapel->setEnglish();
    }

    // alles im Stapelfenster zurueck setzen
    stapel->reset();

    //Das Hauptfenster wieder sichtbar machen
    window->show();
}

# endif
