/*dvd2xvid

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

# include "Lsdvd.h"

# ifndef LSDVD_CPP
# define LSDVD_CPP

Lsdvd::Lsdvd(QComboBox *titel,QComboBox *alang,QComboBox *untertitel,Decodieren *deco,int startdebug)
{
    // Debuglevel setzen
    debuglevel=startdebug;

    sprache="de";

    if(debuglevel>=2)
    {
        cout<<" * Konstructor : Lsdvd *"<<endl<<endl;
    }

    // Der uebergebene Zeiger der ComboBox  die die Auswahl der Titel anzeigt
    cotitel      = titel;
    coalang      = alang;
    countertitel = untertitel;
    decodieren   = deco;
}

void Lsdvd::titeleinlesen(QString dirpfad)
{
    if(debuglevel>=2)
    {
        cout<<" * Slot : dvdeinlesen *"<<endl<<endl;
    }

    // weis den Uebergeben "dirpfad" den "indirpfad" zu
    indirpfad=dirpfad;

    // lsdvd ausfueren lassen
    aufruf_lsdvd("");

    // Oeffnen der ".dvd2xdiv" Datei 
    ifstream einlesen("/tmp/dvd2xvid");

    // Kontrolliert ob die Datei geoeffnet werden konnte
    if(!einlesen)
    {
        // Wenn Oeffnen faehlschlaegt dann eine Meldung ausgeben
        cout<<endl;
        cout<<"*********************************************"<<endl;
        cout<<" * Fehler beim Einlesen der dvd2xvid Datei *"<<endl;
        cout<<" *                                          *"<<endl;
        cout<<" *       Bitte fuer Fehlersuche in den      *"<<endl;
        cout<<" *           Debugmodus wechseln.           *"<<endl;
        cout<<"*********************************************"<<endl;
    }

    // Damit alle eventuell vorhanden Items entfernt werden
    cotitel      -> clear();

    // Solange Zeilen Einlesen bis das Datei Ende erreicht ist
    for(endedatei=false;endedatei==false;)
    {
        // Eine Zeile aus der Datei einlesen und in den temporaere String ablegen
         getline(einlesen,temp);

         if(debuglevel==3)
         {
            cout<<" Temp = " <<temp<<endl;
         }

         // Kontrolle ob die Eingelesen Zeile mit Title beginnte
         if(temp.substr(0,5)=="Title")
         {
             cotitel->insertItem(temp.substr(0,28));
         }

         // Kontrollieren ob die Datei zu Ende ist
         if(einlesen.eof())
         {
            // Wenn ja dann "endedatei auf "true" setzen
            endedatei=true;
         }
    }

    // Damit der Automatisch ausgewaehlte Titel auch nach  Deodieren  gesendet wird
    decodieren->settitel(cotitel->currentItem());

    if(debuglevel==3)
    {
        cout<<endl<<" Einlesen der Tempdatei zu Ende"<<endl<<endl;
        cout<<" Indirpfad = "<<indirpfad<<endl<<endl;
    }
}

void Lsdvd::aufruf_lsdvd(QString option)
{
    // hier wird der String fuer den "system()" aufruf zusammengestellt
    aufruf="lsdvd "+option+" "+indirpfad+" > /tmp/dvd2xvid";

    // ruft lsdvd auf und liest denn Indirordner aus
    system(aufruf);
}

void Lsdvd::audioeinlesen(QString titel)
{
     // Die Audiospuren vom uebergeben Titel auslesen
    aufruf_lsdvd(("-a -t "+titel));

     // Oeffnen der ".dvd2xdiv" Datei 
    ifstream einlesen("/tmp/dvd2xvid");

    // Kontrolliert ob die Datei geoeffnet werden konnte
    if(!einlesen)
    {
        // Wenn Oeffnen faehlschlaegt dann eine Meldung ausgeben
        cout<<endl;
        cout<<"*********************************************"<<endl;
        cout<<" * Fehler beim Einlesen der dvd2xvid Datei *"<<endl;
        cout<<" *                                          *"<<endl;
        cout<<" *       Bitte fuer Fehlersuche in den      *"<<endl;
        cout<<" *           Debugmodus wechseln.           *"<<endl;
        cout<<"*********************************************"<<endl;
    }

    // Damit alle eventuell vorhanden Items entfernt werden
    coalang      -> clear();

    // Solange Zeilen Einlesen bis das Datei Ende erreicht ist
    for(endedatei=false;endedatei==false;)
    {
        // Eine Zeile aus der Datei einlesen und in den temporaere String ablegen
        getline(einlesen,temp);

        if(debuglevel==3)
        {
            cout<<" Temp = " <<temp<<endl;
        }

        if(temp.length()>14)
        {
             // Kontrolle ob diese Zeile Audio daten enthaelt
             if(temp.substr(1,5)=="Audio")
            {
                 // Findet die Position wo der Name der Sprache aufhoert
                  position=temp.find(",",21,true);

                    coalang->insertItem((temp.substr(21,position-21))+" - "
                         +temp.substr(position+1,temp.find(",",position+1,true)-position-1));
             }
        }

        // Kontrollieren ob die Datei zu Ende ist
        if(einlesen.eof())
        {
            // Wenn ja dann "endedatei auf "true" setzen
            endedatei=true;
        }

    }

    // Kontrolle ob es schon Objekte gibt in der Combobox
    if(!((coalang->count())==0))
    {
        // Ersten Eintrag einfuegen und auf die eingestellte Sprache achtgeben
        if(sprache=="de")
        {
            coalang      ->insertItem("Standard Ton",0);
        }

        if(sprache=="en")
        {
            coalang      ->insertItem("Standard audiotrack",0);
        }
    }

    // Damit der Automatisch ausgewaehlte Audiospur auch nach  Deodieren  gesendet wird
    decodieren->setaudio(coalang->currentText());
}

void Lsdvd::untertiteleinlesen (QString titel)
{
    // Die Untertitel vom uebergeben Titel auslesen
    aufruf_lsdvd(("-s -t "+titel));

     // Oeffnen der ".dvd2xdiv" Datei 
    ifstream einlesen("/tmp/dvd2xvid");

    // Kontrolliert ob die Datei geoeffnet werden konnte
    if(!einlesen)
    {
        // Wenn Oeffnen faehlschlaegt dann eine Meldung ausgeben
        cout<<endl;
        cout<<"*********************************************"<<endl;
        cout<<" * Fehler beim Einlesen der dvd2xvid Datei *"<<endl;
        cout<<" *                                          *"<<endl;
        cout<<" *       Bitte fuer Fehlersuche in den      *"<<endl;
        cout<<" *           Debugmodus wechseln.           *"<<endl;
        cout<<"*********************************************"<<endl;
    }

    // Damit alle eventuell vorhanden Items entfernt werden
    countertitel -> clear();

    // Solange Zeilen Einlesen bis das Datei Ende erreicht ist
    for(endedatei=false;endedatei==false;)
    {
        // Eine Zeile aus der Datei einlesen und in den temporaere String ablegen
        getline(einlesen,temp);

        if(debuglevel==3)
        {
            cout<<" Temp = " <<temp<<endl;
        }

        if(temp.length()>14)
        {
            // Kontrolle ob diese Zeile Audio daten enthaelt
            if(temp.substr(1,8)=="Subtitle")
            {
                 // Findet die Position wo der Name der Sprache aufhoert
                 position=temp.find(",",16,true);

                countertitel->insertItem(temp.substr(10,position-10));
            }
        }

        // Kontrollieren ob die Datei zu Ende ist
        if(einlesen.eof())
        {
            // Wenn ja dann "endedatei auf "true" setzen
            endedatei=true;
        }
    }

    // Das Fileobjekt ordnungshalber schlieen
    einlesen.close();

    // Die temporaere Datei gliech loeschen
    system("rm /tmp/dvd2xvid");

    // Kontrolle ob es schon Objekte gibt in der Combobox
    if(!((countertitel->count())==0))
    {
        // Ersten Eintrag einfuegen und auf die eingestellte Sprache achtgeben
        if(sprache=="de")
        {
            countertitel->changeItem("Keine Untertitel",0);
        }

        if(sprache=="en")
        {
            countertitel->insertItem("No subtitle",0);
        }
    }

    // Damit der Automatisch ausgewaehlte Untertitel auch nach  Deodieren  gesendet wird
    decodieren->setuntertitel(countertitel->currentText());
}

void Lsdvd::setDebug (int newDebug)
{
    // Debuglevel neu setzen
    debuglevel=newDebug;
}

void Lsdvd::setDeutsch(void)
{
    // Sprache abspeichern
    sprache="de";

    // Kontrolle ob es schon Objekte gibt in der Combobox
    if(!((coalang->count())==0))
    {
        // Sprache bei den Ueberschriften richtigstellen
        coalang     ->changeItem("Standard Ton",0);
    }

    // Kontrolle ob es schon Objekte gibt in der Combobox
    if(!((countertitel->count())==0))
    {
        // Sprache bei den Ueberschriften richtigstellen
        countertitel->changeItem("Keine Untertitel",0);
    }


}

void Lsdvd::setEnglish(void)
{
    // Sprache abspeichern
    sprache="en";

    if(!((coalang->count())==0))
    {
        // Sprache bei den Ueberschriften richtigstellen
        coalang     ->changeItem("Standard audiotrack",0);
    }

    // Kontrolle ob es schon Objekte gibt in der Combobox
    if(!((countertitel->count())==0))
    {
        // Sprache bei den Ueberschriften richtigstellen
        countertitel->changeItem("No subtitle",0);
    }
}
# endif
